"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var AccordionGroupComponent = (function (_super) {
    __extends(AccordionGroupComponent, _super);
    function AccordionGroupComponent(_translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.idAccordion = '';
        _this.index = '';
        _this.icon = '';
        _this.securityId = '';
        _this.active = false;
        _this._text = '';
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    }
    Object.defineProperty(AccordionGroupComponent.prototype, "text", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._text = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._text = eval(caminhoTraducao);
                }
                else {
                    this._text = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    AccordionGroupComponent.prototype.ngOnInit = function () {
        this.idAccordion = "[index=" + this.index + "]";
        _super.prototype.validar.call(this, this.securityId);
        // this.idAccordion = 'sbm-accordion-' + Math.floor((Math.random() * 1000) + 1);
    };
    AccordionGroupComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.text.substring(0, 1) == '#') {
            this._text = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.text.replace('#', '')];
        }
        else {
            if (this.text.substring(0, 5) == 'i18n.') {
                var colLabel = this.text.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._text = eval(caminhoTraducao);
            }
            else {
                this._text = this.text;
            }
        }
    };
    return AccordionGroupComponent;
}(abstract_ngmodel_1.AbstractNgModel));
AccordionGroupComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-accordion-group',
                template: "\n    <div [hidden]=\"!active\">\n        <ng-template #internalColumnTemplate let-item=\"item\">\n            <ng-content></ng-content>\n        </ng-template>\n    </div>\n    ",
                host: {
                    '[hidden]': '!exibirComponente'
                }
            },] },
];
/** @nocollapse */
AccordionGroupComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
AccordionGroupComponent.propDecorators = {
    'index': [{ type: core_1.Input },],
    'icon': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input, args: ['label',] },],
    'securityId': [{ type: core_1.Input },],
    'active': [{ type: core_1.Input },],
    'columnTemplate': [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
};
exports.AccordionGroupComponent = AccordionGroupComponent;
var AccordionEnum;
(function (AccordionEnum) {
    AccordionEnum[AccordionEnum["primary"] = 0] = "primary";
    AccordionEnum[AccordionEnum["success"] = 1] = "success";
    AccordionEnum[AccordionEnum["warning"] = 2] = "warning";
    AccordionEnum[AccordionEnum["info"] = 3] = "info";
    AccordionEnum[AccordionEnum["danger"] = 4] = "danger";
    AccordionEnum[AccordionEnum["default"] = 5] = "default";
})(AccordionEnum = exports.AccordionEnum || (exports.AccordionEnum = {}));
