"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var req_http_service_1 = require("../../services/req-http.service");
var i18n_1 = require("../../models/i18n");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var AutocompleteComponent = (function (_super) {
    __extends(AutocompleteComponent, _super);
    function AutocompleteComponent(_req, _el, _translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._req = _req;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.dataSource = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.placeholder = 'Digite aqui';
        _this.label = 'AutoComplete';
        _this.text = ['text'];
        _this.textSeparator = '-';
        _this.reqIndexKey = 'data';
        _this.disabled = false;
        _this.readonly = false;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.onClick = new core_1.EventEmitter();
        _this.onBlur = new core_1.EventEmitter();
        _this.onKeyup = new core_1.EventEmitter();
        _this._dataSource = [];
        _this.dataAutocomplete = [];
        _this.randomId = '';
        _this.labelWidth = '';
        _this.isNotMasterDetail = true;
        _this._label = '';
        sbmAutocompleteComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        _this._translateService.onLangChange.subscribe(function (ret) {
            _this.getTranslate();
        });
        return _this;
    }
    Object.defineProperty(AutocompleteComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    AutocompleteComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    AutocompleteComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    AutocompleteComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.autocomplete.nativeElement).attr('style', this.styleCss);
        $(this.autocomplete.nativeElement).focusin(function () {
            me.reqService();
        });
    };
    AutocompleteComponent.prototype.ngAfterViewChecked = function () {
        if ($(this._el.nativeElement).attr('dataSource') != this.dataSource) {
            this.dataSource = $(this._el.nativeElement).attr('dataSource');
            this.reqService();
        }
    };
    AutocompleteComponent.prototype.reqService = function () {
        var _this = this;
        if (this.dataSource != '') {
            if (this._dataSource.length == 0) {
                this._req.xhrGet(this.dataSource).subscribe(function (ret) {
                    _this._dataSource = ret.res[_this.reqIndexKey];
                });
            }
        }
    };
    AutocompleteComponent.prototype.itemClicado = function (event) {
        this.onClick.emit(event);
        this.value = event[this.text[0]];
        $(this.listautocomplete.nativeElement).css('display', 'none');
    };
    AutocompleteComponent.prototype.blur = function ($event) {
        var _this = this;
        this.onBlur.emit($event);
        setTimeout(function () {
            $(_this.listautocomplete.nativeElement).css('display', 'none');
        }, 500);
    };
    AutocompleteComponent.prototype.keyup = function ($event) {
        var _this = this;
        var me = this;
        var value = $event.target.value;
        this.dataAutocomplete = [];
        if (value != '') {
            this._dataSource.filter(function (v, i, a) {
                for (var _i = 0, _a = _this.text; _i < _a.length; _i++) {
                    var item = _a[_i];
                    if (v[item].indexOf(value) > -1) {
                        me.dataAutocomplete.push(v);
                        $(_this.listautocomplete.nativeElement).css('display', 'block');
                    }
                }
            });
        }
        this.onKeyup.emit($event);
    };
    return AutocompleteComponent;
}(abstract_ngmodel_1.AbstractNgModel));
AutocompleteComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-autocomplete',
                styles: ["\n        .list-autocomplete {\n            display: inline-block;\n            padding: 10px 5px 10px 5px;\n        }\n    "],
                template: "\n        <input id=\"{{randomId}}\" #autocomplete type=\"text\" class=\"{{css}}\" [(ngModel)]=\"value\" (blur)=\"blur($event)\"\n         [hidden]=\"!exibirComponente\" (keyup)='keyup($event)' [style]='styleCss' [attr.data-source]=\"dataSource\" [disabled]=\"disabled\" [readonly]=\"readonly\">\n          <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n          <ul style=\"display: none; margin-top: 0px;\" #listautocomplete class=\"autocomplete-content dropdown-content\">\n              <li *ngFor=\"let item of dataAutocomplete\" (click)=\"itemClicado(item)\">\n                <span class=\"list-autocomplete\" *ngFor=\"let a of text, let i = index\"> {{item[a]}} <a *ngIf=\"i+1 != text.length\">{{textSeparator}}</a></span>\n              </li>\n          </ul>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(AutocompleteComponent)]
            },] },
];
/** @nocollapse */
AutocompleteComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
AutocompleteComponent.propDecorators = {
    'autocomplete': [{ type: core_1.ViewChild, args: ['autocomplete',] },],
    'listautocomplete': [{ type: core_1.ViewChild, args: ['listautocomplete',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'textSeparator': [{ type: core_1.Input },],
    'reqIndexKey': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    'onClick': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Output },],
    'onKeyup': [{ type: core_1.Output },],
};
exports.AutocompleteComponent = AutocompleteComponent;
