"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var req_http_service_1 = require("../../services/req-http.service");
var router_1 = require("@angular/router");
var CrudComponent = (function () {
    function CrudComponent(_http, _router, _activatedRoute, _renderer, _el) {
        this._http = _http;
        this._router = _router;
        this._activatedRoute = _activatedRoute;
        this._renderer = _renderer;
        this._el = _el;
        this.entity = '';
        this.filter = '';
        this.masterDetail = false;
        this.selectItems = new core_1.EventEmitter();
        this.onModels = new core_1.EventEmitter();
        this.selectedFilter = false;
        this.setGrid = [];
        this.selectItem = [];
        this.colunas = [];
        this.crudFormAtive = false;
        this.addFormControl = true;
        this.formControlHidden = true;
        this.saveButton = false;
        this.buttonDisable = true;
        this.executedParameters = false;
        this.noErrosForm = true;
    }
    CrudComponent.prototype.selectFilter = function (event) {
        this.dataSource = event;
        this.url = event.url;
        this.selectedFilter = true;
    };
    CrudComponent.prototype.retornoParametro = function (retorno) {
        this.retornoParametros = retorno;
        // esperando serviço para retorno da grid com os registros. no momento vindo de um mock
    };
    CrudComponent.prototype.executarFiltro = function () {
        var _this = this;
        this.setGrid = [];
        this.colunas = [];
        this._http.xhrGet(this.entity).subscribe(function (ret) {
            var arrayGrid = [];
            for (var _i = 0, _a = ret.res; _i < _a.length; _i++) {
                var item = _a[_i];
                var dataGrid = {};
                for (var i = 0; i < item.colunas.length; i++) {
                    // this.colunas.push({
                    //      dataField: item.colunas[0].rotulo,
                    //      caption: item.colunas[0].rotulo,
                    //      width: 200
                    //  });
                    dataGrid[item.colunas[i].rotulo] = item.colunas[i].valor;
                }
                arrayGrid.push(dataGrid);
            }
            _this.setGrid = arrayGrid;
            _this.executedParameters = true;
            $('#icon-button-show-hidden').html('&#xE315;');
            $('#sbm-grid-result').removeClass('l8').addClass('l11');
        });
        /*this._http.xhrPost(this.entity, this.retornoParametros).subscribe((ret: any): any => {
         let dataGrid: any = {};
         let arrayGrid: any = [];
         for (let item of ret.res) {
         for (let i = 0; i < item.colunas.length; i++) {
         this.colunas.push({
         dataField: item.colunas[i].rotulo,
         caption: item.colunas[i].rotulo
         });
         dataGrid[item.colunas[i].rotulo] = item.colunas[i].valor;
         }
         arrayGrid.push(dataGrid);
         }
         this.setGrid = arrayGrid;
         });*/
    };
    CrudComponent.prototype.showParameters = function (hidden) {
        if (hidden) {
            $('#icon-button-show-hidden').html('&#xE314;');
            $('#sbm-grid-result').removeClass('l11').addClass('l7');
            this.executedParameters = false;
        }
        else {
            $('#icon-button-show-hidden').html('&#xE315;');
            $('#sbm-grid-result').removeClass('l7').addClass('l11');
            this.executedParameters = true;
        }
    };
    CrudComponent.prototype.selectionData = function (event) {
        var _this = this;
        this.selectItems.emit(event);
        this.selectItem = event;
        if (event.selectedRowsData.length > 0) {
            this.buttonDisable = false;
            localStorage.setItem('__SBM__dataGrid', JSON.stringify(event.selectedRowsData));
        }
        else {
            this.buttonDisable = true;
            localStorage.setItem('__SBM__dataGrid', '');
        }
        if (this._activatedRoute.routeConfig.data['isChildrenCrud']) {
            this._router.config.map(function (a, i) {
                if (_this._activatedRoute.routeConfig.data['urlAfter'] == '/' + a.path) {
                    a.data['returnData'] = {
                        'data': event.selectedRowsData[0],
                        'id': _this._activatedRoute.routeConfig.data['id'],
                    };
                }
            });
            this._router.navigateByUrl(this._activatedRoute.routeConfig.data['urlAfter']);
        }
    };
    CrudComponent.prototype.ngOnInit = function () {
    };
    return CrudComponent;
}());
CrudComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-crud-depreciated',
                template: "\n        <div class=\"row\" *ngIf='!crudFormAtive'>\n        <div class=\"col l4 m12 s12\" [hidden]=\"executedParameters\" style=\"border-right: 1px solid #a7a7a7;\">\n            <div class=\"col l12 sbm-select\">\n                <sbm-select securityId=\"campo01\" id='campo13' placeholder='- Selecione -' dataSource='{{filter}}'\n                            [text]='[\"nome\"]' label=\"Filtro\"\n                            (_onClick)='selectFilter($event)'></sbm-select>\n            </div>\n            <div class=\"col l12 sbm-parameters\" *ngIf='selectedFilter'>\n                <sbm-parameters [dataSource]='dataSource' (onSave)='retornoParametro($event)' [(models)]=\"parametersModels\"></sbm-parameters>\n                <div style='float: right;'>\n                    <dx-button text='Executar' [type]='normal' (onClick)='executarFiltro()'></dx-button>\n                </div>\n            </div>\n        </div>\n        <div style=\"float:left;margin:5px\">\n             <a class=\"btn-floating btn-small waves-effect waves-light\" (click)=\"showParameters(executedParameters)\">\n                <i id=\"icon-button-show-hidden\" class=\"material-icons\">&#xE314;</i>\n             </a>\n        </div>\n        <div id='sbm-grid-result' class=\"col l7 m12 s12\">\n            <div class=\"col s12 action-bar\">\n                        <span class='action-bar-content'>\n                        <div class=\"row\">\n                        <div class=\"col l12 s12 m12 crud-padding-action\" style=\"border-bottom: 1px solid #a7a7a7;padding-bottom: 8px;\">\n                            <a class=\"btn-floating btn-small waves-effect waves-light  green darken-4\" (click)=\"clickNew()\">\n                                <i class=\"material-icons\">&#xE145;</i>\n                             </a>\n                             <a class=\"btn-floating btn-small waves-effect waves-light light-blue darken-4\" (click)=\"clickEdit(selectItem)\"\n                             *ngIf='!buttonDisable'>\n                                <i class=\"material-icons\">&#xE254;</i>\n                             </a>\n                             <a class=\"btn-floating btn-small waves-effect waves-light red\" (click)=\"clickDelete(selectItem)\"\n                             *ngIf='!buttonDisable'>\n                                <i class=\"material-icons\">&#xE872;</i>\n                             </a>\n                             <ng-content select='[action]'></ng-content>\n                            </div>\n                        </div>\n                        </span>\n            </div>\n            <div class='col l12 m12 s12'>\n                <dx-data-grid style=\"width:100%\" *ngIf='true' id=\"gridContainer\"\n                              [dataSource]='setGrid'\n                              [allowColumnReordering]=\"true\"\n                              [allowColumnResizing]=\"true\"\n                              [columnAutoWidth]=\"true\"\n                              [paging]='{\n                                        pageSize: 10\n                                      }'\n                              [pager]='{\n                                        showPageSizeSelector: false,\n                                        allowedPageSizes: [5, 10, 20],\n                                        showInfo: false,\n                                        showNavigationButtons: false\n                                      }'\n                              [groupPanel]='{\n                                visible: true,\n                                emptyPanelText: \"Agrupar\"\n                              }'\n                              [selection]='{\n                                        mode: \"multiple\"\n                                      }'\n                              (onSelectionChanged)='selectionData($event)'\n                >\n\n                </dx-data-grid>\n                <!--<sbm-grid id='campo25' securityId='campo01' [columns]='colunas' [dataSource]='setGrid'\n                pagination='10' select='multiple' (onSelectData)='selectionData($event)'></sbm-grid>-->\n            </div>\n            <div class=\"col l12 complementary-action-bar\">\n                        <span class=\"complementary-content\">\n                            <ng-content select='[complementary]'></ng-content>\n                        </span>\n            </div>\n        </div>\n\n        <dx-popup\n            [showTitle]=\"true\"\n            title=\"CRUD\"\n            [dragEnabled]=\"false\"\n            [closeOnOutsideClick]=\"true\"\n            [(visible)]=\"popupVisible\">\n            <div *dxTemplate=\"let data of 'content'\">\n                {{selectItem | json}}\n            </div>\n        </dx-popup>\n    </div>\n    \n    <div class=\"row\" [hidden]='formControlHidden'>\n        <div class=\"col l12\">\n            <form #crudFrom #f='ngForm' (ngSubmit)='addFormControls(f)'>\n                <ng-content select='[crud-form]'></ng-content>\n                <div class='col l12 alert alert-danger' id='msgValidations' [hidden]='noErrosForm'></div>\n                <div class='col l12 s12 m12 actions-crud-form'>\n                    <button class='waves-effect waves-light btn red'  (click)='cancel()'>Cancelar</button>\n                    <button class='waves-effect waves-light btn light-blue darken-4' (click)='addFormControls(f, true)'>Salvar e Continuar</button>\n                    <button class='waves-effect waves-light btn green darken-4' (click)='addFormControls(f, false)'>Salvar</button>\n                </div>\n            </form>\n        </div>\n    </div>\n    "
            },] },
];
/** @nocollapse */
CrudComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
    { type: router_1.Router, },
    { type: router_1.ActivatedRoute, },
    { type: core_1.Renderer, },
    { type: core_1.ElementRef, },
]; };
CrudComponent.propDecorators = {
    'entity': [{ type: core_1.Input },],
    'filter': [{ type: core_1.Input },],
    'masterDetail': [{ type: core_1.Input },],
    'selectItems': [{ type: core_1.Output },],
    'onModels': [{ type: core_1.Output },],
};
exports.CrudComponent = CrudComponent;
var CrudComponentEnum;
(function (CrudComponentEnum) {
    CrudComponentEnum[CrudComponentEnum["default"] = 0] = "default";
    CrudComponentEnum[CrudComponentEnum["primary"] = 1] = "primary";
    CrudComponentEnum[CrudComponentEnum["success"] = 2] = "success";
    CrudComponentEnum[CrudComponentEnum["danger"] = 3] = "danger";
    CrudComponentEnum[CrudComponentEnum["warning"] = 4] = "warning";
    CrudComponentEnum[CrudComponentEnum["info"] = 5] = "info";
})(CrudComponentEnum = exports.CrudComponentEnum || (exports.CrudComponentEnum = {}));
