import { EventEmitter, OnInit, ElementRef } from '@angular/core';
import { IComponentDefault } from '../../interfaces/IComponentDefault';
import { AbstractNgModel } from '../../models/abstract.ngmodel';
import { SharedService } from '../../models/sharedService';
import { ReqHttpService } from '../../services/req-http.service';
import { TranslateService } from '@ngx-translate/core';
export declare class DateboxComponent extends AbstractNgModel implements IComponentDefault, OnInit {
    private el;
    private _sharedService;
    private _translateService;
    datebox: ElementRef;
    id: string;
    securityId: string;
    attribute: string;
    min: string;
    max: string;
    private privateLabel;
    label: string;
    css: string;
    styleCss: string;
    defaultValue: number;
    disabled: boolean;
    readonly: boolean;
    isNotMasterDetail: boolean;
    notnull: any;
    _columns: any;
    columns: any;
    displayFormat: any;
    typeDisplay: any;
    _type: any;
    type: any;
    msgError: string;
    inputValid: boolean;
    msgInvalid: boolean;
    randomId: string;
    labelWidth: string;
    value: any;
    valueComp: any;
    _valueEvent: any;
    valueEvent: any;
    textDateBox: any;
    _label: any;
    _onClick: EventEmitter<{}>;
    _onChange: EventEmitter<{}>;
    onClick: string;
    onChange: string;
    private date;
    private picker;
    private pickerElement;
    constructor(el: ElementRef, _sharedService: SharedService, _translateService: TranslateService, _http: ReqHttpService);
    traducao: any;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    isNotBlank(value: any): any;
    getTranslate(): void;
    validDateMin(date: Date, type: string): boolean;
    validDateMax(date: Date, type: string): boolean;
    closeDateBox(): void;
    blur: (date: any) => void;
    keyup($event: string): void;
    regex(value: string): boolean;
}
export declare const DateboxConstDisplayFormat: {
    date: string;
    time: string;
    datetime: string;
};
export declare enum DateboxEnumType {
    date = 0,
    time = 1,
    datetime = 2,
}
