"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var moment = require("moment");
var notification_component_1 = require("../notification/notification.component");
var sharedService_1 = require("../../models/sharedService");
var req_http_service_1 = require("../../services/req-http.service");
var core_2 = require("@ngx-translate/core");
var funcoes_component_1 = require("../../models/funcoes.component");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var i18n_1 = require("../../models/i18n");
var pt_1 = require("../../mocks/i18n/pt");
var DateboxComponent = (function (_super) {
    __extends(DateboxComponent, _super);
    function DateboxComponent(el, _sharedService, _translateService, _http) {
        var _this = _super.call(this) || this;
        _this.el = el;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.min = '';
        _this.max = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.defaultValue = null;
        _this.disabled = false;
        _this.readonly = false;
        _this.isNotMasterDetail = true;
        _this.notnull = false;
        _this._columns = 'col l12 m12 s12 input-field crud-form-dynamic';
        _this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
        _this.msgError = 'Campo Incorreto';
        _this.inputValid = true;
        _this.msgInvalid = false;
        _this.randomId = '';
        _this.labelWidth = '';
        _this.textDateBox = {
            dateMin: '',
            dateMax: ''
        };
        _this._label = '';
        _this._onClick = new core_1.EventEmitter();
        _this._onChange = new core_1.EventEmitter();
        _this.onClick = '';
        _this.onChange = '';
        _this.blur = function (date) {
            console.log(date);
            if (date && date != '') {
                var _splitDate = date.split('/');
                var newDateConcat = _splitDate[2].slice(0, 4) + '-' + _splitDate[1] + '-' + _splitDate[0] + ' ' + _splitDate[2].slice(5, 11);
                var newDate = new Date(newDateConcat);
                var min = true;
                var max = true;
                if (_this.min) {
                    min = _this.validDateMin(newDate, _this.typeDisplay);
                }
                if (_this.max) {
                    max = _this.validDateMax(newDate, _this.typeDisplay);
                }
                if (min && max) {
                    _this.valueEvent = newDate;
                    _this.value = date;
                    _this._onChange.emit(_this.valueEvent);
                    if (_this.onChange != '') {
                        window[_this.onChange](_this.valueEvent);
                    }
                }
                if (_this.notnull && date.length == 0) {
                    _this.inputValid = false;
                    $(_this.datebox.nativeElement).removeClass('valid');
                    $(_this.datebox.nativeElement).addClass('invalid');
                    _this.msgError = 'Campo Obrigatório';
                }
                else {
                    _this.inputValid = true;
                    $(_this.datebox.nativeElement).removeClass('invalid');
                    $(_this.datebox.nativeElement).addClass('valid');
                }
            }
        };
        sbmDateboxComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
    }
    Object.defineProperty(DateboxComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 input-field crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (value) {
            var typeDate = { 'date': 'date', 'time': 'time', 'datetime': 'both' };
            this.typeDisplay = typeDate[value];
            if (value == 'datetime') {
                this.displayFormat = exports.DateboxConstDisplayFormat.datetime;
            }
            if (value == 'date') {
                this.displayFormat = exports.DateboxConstDisplayFormat.date;
            }
            if (value == 'time') {
                this.displayFormat = exports.DateboxConstDisplayFormat.time;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateboxComponent.prototype, "valueEvent", {
        get: function () {
            return this._valueEvent;
        },
        set: function (value) {
            this._valueEvent = value;
            this.closeDateBox();
        },
        enumerable: true,
        configurable: true
    });
    ;
    DateboxComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    };
    DateboxComponent.prototype.ngAfterViewInit = function () {
        /*if (this.defaultValue > 0) {
            let dateCurrent = moment().add(this.defaultValue, 'days').format('DD/MM/YYYY HH:mm');
            // this.value = dateCurrent;
        }*/
        var me = this;
        $(this.datebox.nativeElement).attr('style', this.styleCss);
        $(document).ready(function () {
            if (me.value) {
                $(me.el.nativeElement).find('label').addClass('active');
                me.blur(me.value);
            }
        });
        if (this.typeDisplay == 'both') {
            $(this.datebox.nativeElement).mask('00/00/0000 00:00');
        }
        else if (this.typeDisplay == 'date') {
            $(this.datebox.nativeElement).mask('00/00/0000');
        }
        else if (this.typeDisplay == 'time') {
            $(this.datebox.nativeElement).mask('00:00');
        }
    };
    DateboxComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    DateboxComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    DateboxComponent.prototype.validDateMin = function (date, type) {
        var dateAdd = moment(date).valueOf();
        var minDate = moment().subtract(parseInt(this.min), 'days').valueOf();
        if (date) {
            if (dateAdd < minDate) {
                var newDateConcat = null;
                if (type == 'both') {
                    newDateConcat = moment(minDate).format('DD/MM/YYYY HH:mm');
                }
                else if (type == 'date') {
                    newDateConcat = moment(minDate).format('DD/MM/YYYY');
                }
                this.valueEvent = moment(minDate);
                this.value = newDateConcat;
                var _notification = new notification_component_1.NotificationComponent();
                _notification.show(this.textDateBox['dateMin'] + " " + newDateConcat);
                return false;
            }
            else {
                return true;
            }
        }
    };
    DateboxComponent.prototype.validDateMax = function (date, type) {
        var dateAdd = moment(date).valueOf();
        var maxDate = moment().add(parseInt(this.min), 'days').valueOf();
        if (date) {
            if (dateAdd > maxDate) {
                var newDateConcat = null;
                if (type == 'both') {
                    newDateConcat = moment(maxDate).format('DD/MM/YYYY HH:mm');
                }
                else if (type == 'date') {
                    newDateConcat = moment(maxDate).format('DD/MM/YYYY');
                }
                this.valueEvent = moment(maxDate);
                this.value = newDateConcat;
                var _notification = new notification_component_1.NotificationComponent();
                _notification.show(this.textDateBox['dateMax'] + " " + newDateConcat);
                return false;
            }
            else {
                return true;
            }
        }
    };
    DateboxComponent.prototype.closeDateBox = function () {
        var min = true;
        var max = true;
        if (this.min) {
            min = this.validDateMin(this.valueEvent, this.typeDisplay);
        }
        if (this.max) {
            max = this.validDateMax(this.valueEvent, this.typeDisplay);
        }
        if (min && max) {
            if (this.typeDisplay == 'both') {
                this.value = moment(this.valueEvent).format('DD/MM/YYYY HH:mm');
            }
            else if (this.typeDisplay == 'date') {
                this.value = moment(this.valueEvent).format('DD/MM/YYYY');
            }
            else if (this.typeDisplay == 'time') {
                this.value = moment(this.valueEvent).format('HH:mm');
            }
        }
        $("label[for='" + this.randomId + "']").addClass("active");
        this._onClick.emit(this.valueEvent);
        if (this.onClick != '') {
            window[this.onClick](this.valueEvent);
        }
    };
    DateboxComponent.prototype.keyup = function ($event) {
        // console.log($event)
    };
    DateboxComponent.prototype.regex = function (value) {
        var regexTime = /^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/;
        var regexData = /^([0-2]\d|[3][0-1])\/([0]\d|[1][0-2])\/([1-2]\d{3})(?:(?:\s([0-1]\d|[2][0-3])\:([0-5]\d)(?::([0-5]\d))?)?)$/;
        if (this.typeDisplay == 'both') {
            return regexData.test(value);
        }
        else if (this.typeDisplay == 'date') {
            return regexData.test(value);
        }
        else if (this.typeDisplay == 'time') {
            return regexTime.test(value);
        }
    };
    return DateboxComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DateboxComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-datebox',
                template: "\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        <input id=\"{{randomId}}\" type=\"text\" #datebox [(ngModel)]=\"value\" (keyup)=\"keyup($event)\" [style]=\"styleCss\"\n        [disabled]=\"disabled\" [readonly]=\"readonly\"\n        [(dateTimePicker)]=\"valueEvent\" (blur)=\"blur(datebox.value)\" [pickerType]=\"typeDisplay\" [hourTime]=\"'24'\" locale=\"pt-br\"\n        [locale]=\"'pt-br'\" [mode]=\"'dropdown'\" class=\"{{css}}\"/>\n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns',
                    '[ngClass]': 'options ? options.className : ""'
                },
                providers: [abstract_ngmodel_1.MakeProvider(DateboxComponent)]
            },] },
];
/** @nocollapse */
DateboxComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
    { type: req_http_service_1.ReqHttpService, },
]; };
DateboxComponent.propDecorators = {
    'datebox': [{ type: core_1.ViewChild, args: ['datebox',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'min': [{ type: core_1.Input },],
    'max': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'defaultValue': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'columns': [{ type: core_1.Input },],
    'type': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    '_onChange': [{ type: core_1.Output },],
    'onClick': [{ type: core_1.Input },],
    'onChange': [{ type: core_1.Input },],
};
exports.DateboxComponent = DateboxComponent;
exports.DateboxConstDisplayFormat = {
    date: 'yyyy/M/d',
    time: 'HH:mm',
    datetime: 'dd/MM/yyyy HH:mm:ss'
};
var DateboxEnumType;
(function (DateboxEnumType) {
    DateboxEnumType[DateboxEnumType["date"] = 0] = "date";
    DateboxEnumType[DateboxEnumType["time"] = 1] = "time";
    DateboxEnumType[DateboxEnumType["datetime"] = 2] = "datetime";
})(DateboxEnumType = exports.DateboxEnumType || (exports.DateboxEnumType = {}));
