"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var DropComponent = (function (_super) {
    __extends(DropComponent, _super);
    function DropComponent() {
        var _this = _super.call(this) || this;
        _this._droppedItems = [];
        _this.items = [];
        _this.instanceDrag = [];
        _this.callDrop = new core_1.EventEmitter();
        _this.callBackRemove = new core_1.EventEmitter();
        _this.isDropped = false;
        _this.securityId = '';
        _this.id = '';
        _this.title = '';
        _this.emptyMessage = 'Vazio';
        _this.keepItems = false;
        _this.design = 'simple';
        _this.itemSrc = 'assets';
        _this.itemLink = 'principal';
        _this.itemIcon = 'grade';
        _this.itemTitle = 'title';
        _this.itemDesc = 'title';
        _this.dropScope = ['drop1'];
        _this.dropEnabled = true;
        _this._columns = 'col l12 s12 m12';
        return _this;
    }
    Object.defineProperty(DropComponent.prototype, "droppedItems", {
        get: function () {
            return this._droppedItems;
        },
        set: function (val) {
            this._droppedItems = val;
            // this.value = this._droppedItems;
        },
        enumerable: true,
        configurable: true
    });
    ;
    ;
    Object.defineProperty(DropComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
        },
        enumerable: true,
        configurable: true
    });
    DropComponent.prototype.removeIndexes = function (array) {
        var newValue = [];
        array.forEach(function (item) {
            var keys = Object.keys(item);
            var object = {};
            keys.forEach(function (key) {
                if (key != 'dragScope' && key != 'index' && key != 'drag_visible') {
                    object[key] = item[key];
                }
            });
            newValue.push(object);
        });
        return newValue;
    };
    DropComponent.prototype.dragEnd = function (e, instanceDrag) {
        var _this = this;
        var items = instanceDrag['instance']['items'];
        items.forEach(function (item) {
            if (JSON.stringify(item) == JSON.stringify(e)) {
                instanceDrag['instance']['items'][e['index']]['drag_visible'] = true;
            }
        });
        instanceDrag['instance'].itemsHide = instanceDrag['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
        this.droppedItems.forEach(function (item, index) {
            if (JSON.stringify(item) == JSON.stringify(e)) {
                _this.droppedItems.splice(index, 1);
                _this.instanceDrag.splice(index, 1);
            }
        });
        this.value = this.droppedItems;
    };
    DropComponent.prototype.onItemDrop = function (e) {
        // this.callDrop.emit({'dropItem': e, 'dropped': true});
        this.isDropped = true;
        var element = e;
        if (this.droppedItems.length > 0) {
            var newItem = this.droppedItems.filter(function (item) { return JSON.stringify(item) == JSON.stringify(element['dragData']['item']); });
            if (newItem.length == 0) {
                this.droppedItems.push(element['dragData']['item']);
                this.instanceDrag.push(element['dragData']);
            }
        }
        else {
            this.droppedItems.push(element['dragData']['item']);
            this.instanceDrag.push(element['dragData']);
        }
        if (e['dragData']['instance']) {
            if (!e['dragData']['instance']['keepItems']) {
                e['dragData']['instance'].items[e['dragData']['item']['index']].drag_visible = false;
                e['dragData']['instance'].itemsHide = e['dragData']['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
            }
        }
        this.value = this.removeIndexes(this.droppedItems);
    };
    DropComponent.prototype.removeItem = function ($item) {
        this.callBackRemove.emit($item);
    };
    DropComponent.prototype.ngOnInit = function () {
        this.validar(this.securityId);
    };
    DropComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.onChangeValue.subscribe(function (val) {
            if (typeof val === 'object') {
                if (val.length === 0) {
                    if (_this.instanceDrag.length > 0) {
                        _this.instanceDrag.forEach(function (drag) {
                            if (drag['instance'].items.length > 0) {
                                drag['instance'].items.forEach(function (item, index) {
                                    item['drag_visible'] = true;
                                });
                                drag['instance'].itemsHide = drag['instance'].items.filter(function (itm) { return (itm['drag_visible']); });
                            }
                        });
                    }
                    _this.droppedItems = [];
                }
            }
        });
    };
    return DropComponent;
}(abstract_ngmodel_1.AbstractNgModel));
DropComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-drop',
                template: "\n      <div class=\"card\" droppable (onDrop)=\"onItemDrop($event)\" [dropScope]=\"dropScope\" [dropEnabled]=\"dropEnabled\">\n        <div class=\"card-content\">\n            <span class=\"card-title\" *ngIf=\"title != ''\">{{title}}</span>\n            <div class=\"content-drag-drop\">\n              <ul class=\"collection\">\n                  <li draggable *ngFor=\"let item of droppedItems; index as i\" [dragData]=\"{item: item}\" [dragScope]=\"item.dragScope\" (onDragEnd)=\"dragEnd(item, instanceDrag[i])\"\n                  class=\"collection-item {{design=='avatar' ? 'avatar' : ''}} {{item[itemDisable] ? '' : 'li-no-selection' }}\">\n                    <img *ngIf=\"design=='avatar'\" [src]=\"item[itemSrc]\" [alt]=\"item[itemSrc]\" class=\"circle\">\n                    <span class=\"title\">{{item[itemTitle]}}</span>\n                    <p>{{item[itemDesc]}}</p>               \n                    <a *ngIf=\"design=='avatar' || design=='secundary'\" [routerLink]=\"item[itemLink]\" class=\"secondary-content\"><i class=\"material-icons\">{{item[itemIcon]}}</i></a>\n                  </li>\n                  <li *ngIf=\"droppedItems.length == 0\" class=\"collection-item collection-item-empty {{design=='avatar' ? 'avatar' : ''}}\">{{emptyMessage}}</li>\n              </ul>\n            </div>\n        </div>\n      </div>\n  ",
                styles: ["\n    \n  "],
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(DropComponent)]
            },] },
];
/** @nocollapse */
DropComponent.ctorParameters = function () { return []; };
DropComponent.propDecorators = {
    'securityId': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'title': [{ type: core_1.Input },],
    'emptyMessage': [{ type: core_1.Input },],
    'keepItems': [{ type: core_1.Input },],
    'design': [{ type: core_1.Input },],
    'itemSrc': [{ type: core_1.Input },],
    'itemLink': [{ type: core_1.Input },],
    'itemIcon': [{ type: core_1.Input },],
    'itemTitle': [{ type: core_1.Input },],
    'itemDesc': [{ type: core_1.Input },],
    'dropScope': [{ type: core_1.Input },],
    'dropEnabled': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.DropComponent = DropComponent;
