"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var FieldsetComponent = (function (_super) {
    __extends(FieldsetComponent, _super);
    function FieldsetComponent(_el, _sharedService, _translateService) {
        var _this = _super.call(this) || this;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.valign = '';
        _this.halign = '';
        _this.css = 'sbm-fieldset';
        _this._columns = 'col l12 s12 m12';
        _this.textWidth = '';
        _this._label = '';
        _this.setContent = function (content) {
            $(_this.sbmFieldSetContent.nativeElement).html(content);
        };
        sbmFieldsetComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
    }
    Object.defineProperty(FieldsetComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FieldsetComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12";
        },
        enumerable: true,
        configurable: true
    });
    FieldsetComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    };
    FieldsetComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    FieldsetComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.sbmFieldSetContent.nativeElement).children().each(function (index, element) {
                $(element).addClass(_this.halign);
            });
            // this.textWidth = ($(this._el.nativeElement).outerWidth() - 20)+ 'px';
            $(window).resize(function () {
                // this.textWidth = ($(this._el.nativeElement).outerWidth() - 20)+ 'px';
            });
        });
    };
    return FieldsetComponent;
}(abstract_ngmodel_1.AbstractNgModel));
FieldsetComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-fieldset',
                template: "\n        <fieldset #fieldset class=\"{{css}}\">\n            <legend class=\"sbm-input-text\" [ngStyle]=\"{'max-width': textWidth}\">&nbsp;{{_label}}&nbsp;</legend>\n            <div #sbmFieldSetContent class=\"sbm-fieldset-content\">\n                <ng-content></ng-content>\n            </div>\n        </fieldset>\n    ",
                host: {
                    '[class]': 'columns'
                }
            },] },
];
/** @nocollapse */
FieldsetComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
FieldsetComponent.propDecorators = {
    'fieldset': [{ type: core_1.ViewChild, args: ['fieldset',] },],
    'sbmFieldSetContent': [{ type: core_1.ViewChild, args: ['sbmFieldSetContent',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'valign': [{ type: core_1.Input },],
    'halign': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.FieldsetComponent = FieldsetComponent;
