"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var notification_component_1 = require("../notification/notification.component");
var alert_component_1 = require("../alert/alert.component");
var req_http_service_1 = require("../../services/req-http.service");
var ActionBarComponent = (function () {
    function ActionBarComponent() {
    }
    return ActionBarComponent;
}());
ActionBarComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-action-bar',
                template: "<ng-content select='[sbm-action-bar]'></ng-content>"
            },] },
];
/** @nocollapse */
ActionBarComponent.ctorParameters = function () { return []; };
exports.ActionBarComponent = ActionBarComponent;
var ActionComplementaryBarComponent = (function () {
    function ActionComplementaryBarComponent() {
    }
    return ActionComplementaryBarComponent;
}());
ActionComplementaryBarComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-complementary-action-bar',
                template: "<ng-content select='[sbm-complementary-action-bar]'></ng-content>"
            },] },
];
/** @nocollapse */
ActionComplementaryBarComponent.ctorParameters = function () { return []; };
exports.ActionComplementaryBarComponent = ActionComplementaryBarComponent;
var FiltersComponent = (function () {
    function FiltersComponent(_http) {
        this._http = _http;
        this.entity = '';
        this.filter = '';
        this.selectItems = new core_1.EventEmitter();
        this.selectedFilter = false;
        this.setGrid = [];
        this.colunas = [];
        this.selectItem = [];
        this.popupVisible = false;
        this.buttonDisable = true;
        this.url = '';
    }
    FiltersComponent.prototype.retornoParametro = function (retorno) {
        this.retornoParametros = retorno;
        // esperando serviço para retorno da grid com os registros. no momento vindo de um mock
    };
    FiltersComponent.prototype.executarFiltro = function () {
        var _this = this;
        this.setGrid = [];
        this.colunas = [];
        this._http.xhrPost(this.entity, this.retornoParametros).subscribe(function (ret) {
            var dataGrid = {};
            var arrayGrid = [];
            for (var _i = 0, _a = ret.res; _i < _a.length; _i++) {
                var item = _a[_i];
                for (var i = 0; i < item.colunas.length; i++) {
                    _this.colunas.push({
                        dataField: item.colunas[i].rotulo,
                        caption: item.colunas[i].rotulo
                    });
                    dataGrid[item.colunas[i].rotulo] = item.colunas[i].valor;
                }
                arrayGrid.push(dataGrid);
            }
            _this.setGrid = arrayGrid;
        });
    };
    FiltersComponent.prototype.selectFilter = function (event) {
        this.dataSource = event;
        this.url = event.url;
        this.selectedFilter = true;
    };
    FiltersComponent.prototype.selectionData = function (event) {
        this.selectItems.emit(event);
        if (event.selectedRowsData.length > 0) {
            localStorage.setItem('data', JSON.stringify(event.selectedRowsData));
            // this.buttonDisable = false;
        }
        else {
            localStorage.setItem('data', '');
        }
    };
    FiltersComponent.prototype.cliqueButton = function (type) {
        // esperando serviço de crud para editar e adicionar um novo registro
        var _data = localStorage.getItem('data');
        var data = JSON.parse(_data);
        if (type == 'editar') {
            if (data.length > 1) {
                var notification = new notification_component_1.NotificationComponent();
                notification.show('Para editar selecione somente um registro');
            }
            else {
                this.popupVisible = true;
                this.selectItem = data;
            }
        }
        else if (type == 'novo') {
            this.popupVisible = true;
            this.selectItem = [];
        }
        else if (type == 'excluir') {
            var alert_1 = new alert_component_1.AlertComponent();
            alert_1.show('Excluir', 'Deseja excluir o(s) registro(s)?', 'ok')
                .then(function (ret) {
                if (ret) {
                    // esperando serviço de exclusão de registro(s)
                }
            });
        }
    };
    FiltersComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._http.xhrGet(this.filter).subscribe(function (ret) { return _this.filtro = ret.res; });
    };
    return FiltersComponent;
}());
FiltersComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-filter',
                template: "\n        <div class=\"col-md-12\">\n            <div class=\"col-md-4\">\n                <div class=\"col-md-12 sbm-select\">\n                    <sbm-select securityId=\"campo01\" id='campo13' placeholder='- Selecione -' [dataSource]='filtro'\n                                displayExpr='nome'\n                                (onClick)='selectFilter($event)'></sbm-select>\n                </div>\n                <div class=\"col-md-12 sbm-parameters\" *ngIf='selectedFilter'>\n                    <sbm-parameters [dataSource]='dataSource' (onSave)='retornoParametro($event)'></sbm-parameters>\n                    <div style='float: right;'>\n                        <dx-button text='Executar' [type]='normal' (onClick)='executarFiltro()'></dx-button>\n                    </div>\n                </div>\n            </div>\n            <div class=\"col-md-8\">\n                <div class=\"col-md-12 action-bar\">\n                    <span class='action-bar-content'>\n                        <ng-content select='[action]'></ng-content>\n                    </span>\n                </div>\n                <div class='col-md-12'>\n                    <dx-data-grid *ngIf='true' id=\"gridContainer\"\n                                  [dataSource]='setGrid'\n                                  [columns]='colunas'\n                                  [paging]='{\n                                    pageSize: 10\n                                  }'\n                                  [pager]='{\n                                    showPageSizeSelector: false,\n                                    allowedPageSizes: [5, 10, 20],\n                                    showInfo: false,\n                                    showNavigationButtons: false\n                                  }'\n                                  [selection]='{\n                                    mode: \"multiple\"\n                                  }'\n                                  (onSelectionChanged)='selectionData($event)'\n                    >\n        \n                    </dx-data-grid>\n                    <!--<sbm-grid id='campo25' securityId='campo01' [columns]='colunas' [dataSource]='setGrid' \n                    pagination='10' select='multiple' (onSelectData)='selectionData($event)'></sbm-grid>-->\n                </div>\n                <div class=\"col-md-12 complementary-action-bar\">\n                    <span class=\"complementary-content\">\n                        <ng-content select='[complementary]'></ng-content>\n                    </span>\n                </div>\n            </div>\n        </div>\n        \n        <dx-popup\n                [showTitle]=\"true\"\n                title=\"CRUD\"\n                [dragEnabled]=\"false\"\n                [closeOnOutsideClick]=\"true\"\n                [(visible)]=\"popupVisible\">\n            <div *dxTemplate=\"let data of 'content'\">\n                {{selectItem | json}}\n            </div>\n        </dx-popup>\n    "
            },] },
];
/** @nocollapse */
FiltersComponent.ctorParameters = function () { return [
    { type: req_http_service_1.ReqHttpService, },
]; };
FiltersComponent.propDecorators = {
    'entity': [{ type: core_1.Input },],
    'filter': [{ type: core_1.Input },],
    'selectItems': [{ type: core_1.Output },],
};
exports.FiltersComponent = FiltersComponent;
