"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var i18n_1 = require("../../../models/i18n");
var req_http_service_1 = require("../../../services/req-http.service");
var InputCepComponent = (function (_super) {
    __extends(InputCepComponent, _super);
    function InputCepComponent(_http, _reqHttp, _sharedService, _translateService) {
        var _this = _super.call(this) || this;
        _this._http = _http;
        _this._reqHttp = _reqHttp;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.disabled = false;
        _this.readonly = false;
        _this.notnull = false;
        _this._columns = 'input-field col l12 m12 s12 sbm-input-cep crud-form-dynamic';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this._onClick = new core_1.EventEmitter();
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.onClick = '';
        _this.isNotMasterDetail = true;
        _this.msgError = 'Cep Inválido';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.inputValid = true;
        _this.validationsMsg = {
            require: null,
            zipNotFound: null,
            zipCodeInvalid: null,
        };
        _this._label = '';
        sbmInputCepComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    }
    Object.defineProperty(InputCepComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputCepComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field suffix col l" + value + " sbm-input-cep m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputCepComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    InputCepComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputCepComponent.prototype.ngAfterViewInit = function () {
        $(this.inputCep.nativeElement).mask('00.000-000');
        $(this.inputCep.nativeElement).attr('style', this.styleCss);
    };
    InputCepComponent.prototype.itemClicado = function () {
        var _this = this;
        var url = 'http://cep.republicavirtual.com.br/web_cep.php?cep=' + this.value + '&formato=json';
        this.disabled = true;
        this._http.get(url).map(function (res) { return res.json(); }).subscribe(function (retorno) {
            _this._onClick.emit(retorno);
            if (_this.onClick != '') {
                window[_this.onClick](retorno);
            }
            if (retorno.resultado == '0') {
                _this.inputValid = false;
                $(_this.inputCep.nativeElement).removeClass('valid');
                $(_this.inputCep.nativeElement).addClass('invalid');
                _this.msgError = _this.validationsMsg['zipNotFound'];
            }
            _this.disabled = false;
        });
    };
    InputCepComponent.prototype.regex = function (value) {
        var regexCep = /\d{2}\.\d{3}\-\d{3}/;
        return regexCep.test(value);
    };
    InputCepComponent.prototype.blur = function ($event) {
        var value = $event.target.value;
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.inputCep.nativeElement).removeClass('valid');
            $(this.inputCep.nativeElement).addClass('invalid');
            this.msgError = this.validationsMsg['require'];
        }
        else {
            if (this.regex(value)) {
                this.inputValid = true;
                $(this.inputCep.nativeElement).removeClass('invalid');
                $(this.inputCep.nativeElement).addClass('valid');
                this.msgError = this.validationsMsg['zipCodeInvalid'];
            }
            else {
                this.inputValid = false;
                $(this.inputCep.nativeElement).removeClass('valid');
                $(this.inputCep.nativeElement).addClass('invalid');
            }
        }
    };
    InputCepComponent.prototype.keyup = function ($event) {
        var value = $event.target.value;
        if (this.regex(value)) {
            this.inputValid = true;
            $(this.inputCep.nativeElement).removeClass('invalid');
            $(this.inputCep.nativeElement).addClass('valid');
            this.msgError = this.validationsMsg['zipCodeInvalid'];
        }
        else {
            this.inputValid = false;
            $(this.inputCep.nativeElement).removeClass('valid');
            $(this.inputCep.nativeElement).addClass('invalid');
        }
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    return InputCepComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputCepComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-cep',
                styles: ["\n       .smb-input-cep-busca {\n            color: #383838; \n            right: 10px;\n            top: 20px;\n            cursor: pointer;\n            position: absolute;\n        }\n    "],
                template: "\n        <input id=\"{{randomId}}\" #inputCep type=\"text\" class=\"sbm-text-field {{css}}\" [(ngModel)]=\"value\" (blur)=\"blur($event)\"\n        [maxlength]=\"maxLength\" [hidden]=\"!exibirComponente\" (keyup)='keyup($event)' [style]='styleCss' \n               [disabled]=\"disabled\" [readonly]=\"readonly\">\n        <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n        \n        <span class=\"suffix\">\n            <a class=\"btn btn-floating waves-effect sbm-inputcep-search\"\n               [ngClass]=\"{'disabled': disabled}\"\n               (click)='itemClicado()'><i class=\"material-icons\">search</i></a>\n        </span>\n        \n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputCepComponent)]
            },] },
];
/** @nocollapse */
InputCepComponent.ctorParameters = function () { return [
    { type: http_1.Http, },
    { type: req_http_service_1.ReqHttpService, },
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
InputCepComponent.propDecorators = {
    'inputCep': [{ type: core_1.ViewChild, args: ['inputCep',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'columns': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    '_onClick': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
    'onClick': [{ type: core_1.Input },],
};
exports.InputCepComponent = InputCepComponent;
