"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var InputEmailComponent = (function (_super) {
    __extends(InputEmailComponent, _super);
    function InputEmailComponent(_translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.inputValid = true;
        _this._label = '';
        sbmInputEmailComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    }
    Object.defineProperty(InputEmailComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputEmailComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputEmailComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputEmailComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    InputEmailComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            $(_this.inputEmail.nativeElement).attr('style', _this.styleCss);
        });
    };
    InputEmailComponent.prototype.validEmail = function (retorno) {
        this._onBlur.emit(retorno);
        var value = retorno.target.value;
        var usuario = value.substring(0, value.indexOf('@'));
        var dominio = value.substring(value.indexOf('@') + 1, value.lenght);
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.inputEmail.nativeElement).removeClass('valid');
            $(this.inputEmail.nativeElement).addClass('invalid');
            this.msgError = 'Campo Obrigatório';
        }
        else {
            this.inputValid = false;
            $(this.inputEmail.nativeElement).removeClass('invalid');
            $(this.inputEmail.nativeElement).addClass('valid');
        }
        if ((usuario.length >= 1) &&
            (dominio.length >= 3) &&
            (usuario.search('@') == -1) &&
            (dominio.search('@') == -1) &&
            (usuario.search(' ') == -1) &&
            (dominio.search(' ') == -1) &&
            (dominio.search('.') != -1) &&
            (dominio.indexOf('.') >= 1) &&
            (dominio.lastIndexOf('.') < dominio.length - 1)) {
            this.inputValid = true;
            $(this.inputEmail.nativeElement).removeClass('invalid');
            $(this.inputEmail.nativeElement).addClass('valid');
        }
        else {
            this.inputValid = false;
            $(this.inputEmail.nativeElement).removeClass('valid');
            $(this.inputEmail.nativeElement).addClass('invalid');
            this.msgError = 'Email inválido';
        }
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputEmailComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    return InputEmailComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputEmailComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-email',
                template: "\n        <input id=\"{{randomId}}\" #inputEmail type=\"email\" class=\"sbm-text-field {{css}}\" [(ngModel)]=\"value\" (blur)=\"validEmail($event)\"\n           [hidden]=\"!exibirComponente\" (keyup)='keyup($event)' [style]='styleCss' [disabled]=\"disabled\" [readonly]=\"readonly\">\n          <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n          \n          <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputEmailComponent)]
            },] },
];
/** @nocollapse */
InputEmailComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
InputEmailComponent.propDecorators = {
    'inputEmail': [{ type: core_1.ViewChild, args: ['inputEmail',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'styleCss': [{ type: core_1.Input },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
};
exports.InputEmailComponent = InputEmailComponent;
