"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var funcoes_component_1 = require("../../../models/funcoes.component");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var sharedService_1 = require("../../../models/sharedService");
var InputMaskComponent = (function (_super) {
    __extends(InputMaskComponent, _super);
    function InputMaskComponent(_sharedService, _translateService) {
        var _this = _super.call(this) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.placeholder = 'Informe um valor';
        _this.mask = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.notnull = false;
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.isNotMasterDetail = true;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.inputValid = true;
        _this.msgError = '';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.validationsMsg = {
            "require": null
        };
        _this._label = '';
        sbmInputMaskComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.validationsMsg['require'] = ret.translations['i18n'][this.traducao.pJson['name']].validations.fieldRequire;
            this.validationsMsg['minLength'] = ret.translations['i18n'][this.traducao.pJson['name']].validations.fieldMinLength;
            this.validationsMsg['maxLength'] = ret.translations['i18n'][this.traducao.pJson['name']].validations.fieldMaxLength;
            this.validationsMsg['pattern'] = ret.translations['i18n'][this.traducao.pJson['name']].validations.pattern;
            this.msgError = ret.translations['i18n'][this.traducao.pJson['name']].validations.fieldErrorDefault;
        });*/
    }
    Object.defineProperty(InputMaskComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputMaskComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputMaskComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    InputMaskComponent.prototype.validInput = function (retorno) {
        var value = retorno.target.value.replace(/\s{2,}/g, '');
        this._onBlur.emit(retorno);
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.inputMask.nativeElement).addClass('invalid');
            this.msgError = this.validationsMsg['require'];
        }
        else {
            this.inputValid = true;
            $(this.inputMask.nativeElement).addClass('valid');
        }
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputMaskComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    InputMaskComponent.prototype.ngAfterViewInit = function () {
        $(this.inputMask.nativeElement).mask(this.mask);
        $(this.inputMask.nativeElement).attr('style', this.styleCss);
    };
    InputMaskComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
        this._translateService.onLangChange.subscribe(function (ret) {
            _this.getTranslate();
        });
    };
    InputMaskComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    return InputMaskComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputMaskComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-mask',
                template: "       \n        <input id=\"{{randomId}}\" #inputMask type=\"text\" class=\"sbm-text-field {{css}}\" [(ngModel)]=\"value\" (blur)=\"validInput($event)\" \n        [hidden]=\"!exibirComponente\" (keyup)='keyup($event)' [style]='styleCss' [disabled]=\"disabled\" [readonly]=\"readonly\">\n        <label class=\"truncate sbm-label\" for=\"{{randomId}}\">{{_label}}</label>\n        \n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputMaskComponent)]
            },] },
];
/** @nocollapse */
InputMaskComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
InputMaskComponent.propDecorators = {
    'inputMask': [{ type: core_1.ViewChild, args: ['inputMask',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'mask': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
};
exports.InputMaskComponent = InputMaskComponent;
