"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var InputNumberComponent = (function (_super) {
    __extends(InputNumberComponent, _super);
    function InputNumberComponent(_translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.min = null;
        _this.max = null;
        _this.step = '';
        _this.css = 'sbm-input';
        _this.styleCss = '';
        _this.digitAlign = 'right';
        _this.spinButtons = true;
        _this.placeholder = 'Informe Um Valor';
        _this.isNotMasterDetail = true;
        _this.disabled = false;
        _this.readonly = false;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.notnull = false;
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this.patternNumber = '';
        _this.dir = 'ltr';
        _this._label = '';
        sbmInputNumberComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    }
    Object.defineProperty(InputNumberComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputNumberComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputNumberComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        var value = $(this.inputNumber.nativeElement).val();
        var valueInt = parseInt($event.key);
        if (Number.isNaN(valueInt)) {
            $(this.inputNumber.nativeElement).val(value.replace($event.key, ''));
        }
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
            // sbmExecuteFunctions($event, this._onKeyup);
        }
    };
    InputNumberComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        var value = $event.target.value;
        if (parseInt(value) < this.min) {
            $(this.inputNumber.nativeElement).val(this.min);
        }
        if (parseInt(value) > this.max) {
            $(this.inputNumber.nativeElement).val(this.max);
        }
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.inputNumber.nativeElement).removeClass('valid');
            $(this.inputNumber.nativeElement).addClass('invalid');
            this.msgError = 'Campo Obrigatório';
        }
        else {
            this.inputValid = true;
            $(this.inputNumber.nativeElement).removeClass('invalid');
            $(this.inputNumber.nativeElement).addClass('valid');
        }
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    InputNumberComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.inputNumber.nativeElement).attr('style', this.styleCss);
        if (!this.spinButtons) {
            $(this.inputNumber.nativeElement).addClass('no-spinButtons');
        }
        if (this.digitAlign == 'right') {
            $(this.inputNumber.nativeElement).css('text-align', 'right');
            // this.dir = 'ltr';
        }
        else if (this.digitAlign == 'left') {
            $(this.inputNumber.nativeElement).css('text-align', 'left');
            // this.dir = 'rtl';
        }
        else if (this.digitAlign == 'center') {
            $(this.inputNumber.nativeElement).css('text-align', 'center');
            // this.dir = 'ltr';
        }
    };
    InputNumberComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
        this.patternNumber = "[0-9]{" + this.min + ", " + this.max + "}";
    };
    InputNumberComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    return InputNumberComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputNumberComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-number',
                template: "\n        <input id=\"{{randomId}}\" #inputNumber type=\"number\" pattern=\"{{patternNumber}}\" class=\"sbm-text-field {{css}}\" [min]=\"min\" [max]=\"max\" [(ngModel)]=\"value\" (blur)=\"blur($event)\"\n          [hidden]=\"!exibirComponente\" (keyup)='keyup($event)' [style]='styleCss' [dir]=\"dir\" [step]=\"step\" \n          [disabled]=\"disabled\" [readonly]=\"readonly\">\n          <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n          \n          <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputNumberComponent)]
            },] },
];
/** @nocollapse */
InputNumberComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
InputNumberComponent.propDecorators = {
    'inputNumber': [{ type: core_1.ViewChild, args: ['inputNumber',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'min': [{ type: core_1.Input },],
    'max': [{ type: core_1.Input },],
    'step': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'digitAlign': [{ type: core_1.Input },],
    'spinButtons': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
};
exports.InputNumberComponent = InputNumberComponent;
