"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var funcoes_component_1 = require("../../../models/funcoes.component");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var i18nTranslate_1 = require("../../../services/i18nTranslate");
var InputTextComponent = (function (_super) {
    __extends(InputTextComponent, _super);
    function InputTextComponent(_el, _sharedService, _i18nTranslate, _translateService) {
        var _this = _super.call(this) || this;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this._i18nTranslate = _i18nTranslate;
        _this._translateService = _translateService;
        _this.id = '';
        _this.securityId = 'securityId';
        _this.attribute = '';
        _this.placeholder = 'Informe um valor';
        _this.css = 'sbm-input';
        _this.notnull = false;
        _this.maxLength = '';
        _this.minLength = '';
        _this.pattern = '';
        _this.styleCss = '';
        _this.digitText = 'Mm';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.disabled = false;
        _this.readonly = false;
        _this._label = '';
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.inputValid = true;
        _this.labelWidth = '';
        _this.msgError = 'Campo Incorreto';
        _this.isNotMasterDetail = true;
        _this.randomId = '';
        _this.validationsMsg = {
            require: null,
            minLength: null,
            maxLength: null,
            pattern: null,
        };
        sbmInputTextComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
    }
    Object.defineProperty(InputTextComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    if (eval(this._translateService.translations[this._translateService.currentLang])) {
                        var colLabel = val.replace("i18n.", "").split('.');
                        var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                        for (var i = 0; i < colLabel.length; i++) {
                            caminhoTraducao += "['" + colLabel[i] + "']";
                        }
                        var traducao = this._i18nTranslate.getLanguage();
                        console.log(this._i18nTranslate);
                        console.log(traducao);
                        console.log(this._translateService);
                        console.log(this._translateService.currentLang);
                        console.log(this._translateService.translations[this._translateService.currentLang]);
                        this._label = eval(caminhoTraducao);
                    }
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputTextComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    InputTextComponent.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    InputTextComponent.prototype.getTranslate = function () {
        /*let packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        } else {
            if (this.label.substring(0, 5) == 'i18n.') {
                if (eval(this._translateService.translations[this._translateService.currentLang])) {
                    let colLabel = this.label.replace("i18n.", "").split('.');
                    let caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";

                    for (let i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }

                    this._label = eval(caminhoTraducao);
                }
            } else {
                this._label = this.label;
            }
        }*/
    };
    InputTextComponent.prototype.regex = function (value) {
        var me = this;
        var SETRegex = function (val) {
            return new RegExp("\\b" + me.pattern + "\\b");
        };
        var regexText = SETRegex(value);
        return regexText.test(value);
    };
    InputTextComponent.prototype.keyupFunction = function ($event) {
        var value = $event.target.value;
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
        if (this.minLength != '') {
            if (value.length < parseInt(this.minLength)) {
                this.inputValid = false;
                $(this.inputText.nativeElement).removeClass('valid');
                $(this.inputText.nativeElement).addClass('invalid');
                this.msgError = (this.validationsMsg['minLength'] ? this.validationsMsg['minLength'].replace("%", "" + this.minLength) : '');
            }
            else {
                this.inputValid = true;
                $(this.inputText.nativeElement).removeClass('invalid');
                $(this.inputText.nativeElement).addClass('valid');
            }
        }
    };
    InputTextComponent.prototype.validInput = function (retorno) {
        var value = retorno.target.value;
        this._onBlur.emit(retorno);
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.inputText.nativeElement).removeClass('valid');
            $(this.inputText.nativeElement).addClass('invalid');
            this.msgError = this.validationsMsg['require'];
        }
        else {
            if (this.minLength != '') {
                if (value.length < parseInt(this.minLength)) {
                    this.msgError = (this.validationsMsg['minLength'] ? this.validationsMsg['minLength'].replace("%", "" + this.minLength) : '');
                    $(this.inputText.nativeElement).removeClass('valid');
                    $(this.inputText.nativeElement).addClass('invalid');
                }
                else {
                    $(this.inputText.nativeElement).removeClass('invalid');
                    $(this.inputText.nativeElement).addClass('valid');
                    this.inputValid = true;
                }
            }
            else {
                $(this.inputText.nativeElement).removeClass('invalid');
                $(this.inputText.nativeElement).addClass('valid');
                this.inputValid = true;
            }
        }
        if (this.onBlur != '') {
            window[this.onBlur](retorno);
        }
    };
    InputTextComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        var me = this;
        $(document).ready(function () {
            if (_this.maxLength != '') {
                $(me.inputText.nativeElement).attr('data-length', _this.maxLength);
                $(me.inputText.nativeElement).characterCounter();
                $(me._el.nativeElement).find('span.character-counter').css({
                    'float': 'righ',
                    'font-size': '12px',
                    'background-color': '#e53935',
                    'color': '#fff',
                    'margin': '5px',
                    'border-radius': '5px',
                    'right': '0px',
                    'z-index': '9999',
                    'height': '18px',
                    'position': 'absolute',
                });
            }
            me.ngModelText.valueChanges.subscribe(function (ret) {
                Materialize.updateTextFields();
            });
        });
        $(me._el.nativeElement).find('input').attr('style', me.styleCss);
        this.subscriptionValue = this.onChangeValue.subscribe(function (value) {
            if (_this.digitText == 'M') {
                _this.value = value.toUpperCase();
            }
            else if (_this.digitText == 'm') {
                _this.value = value.toLowerCase();
            }
        });
    };
    InputTextComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    InputTextComponent.prototype.ngOnDestroy = function () {
        this.subscriptionValue.unsubscribe();
    };
    return InputTextComponent;
}(abstract_ngmodel_1.AbstractNgModel));
InputTextComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-input-text',
                template: "      \n          <input id=\"{{randomId}}\" #inputText #ngModelInput=\"ngModel\" type=\"text\" class=\"sbm-text-field {{css}}\" \n          [(ngModel)]=\"value\" (blur)=\"validInput($event)\" [maxlength]=\"maxLength\" [hidden]=\"!exibirComponente\" \n          [pattern]=\"pattern\" (keyup)='keyupFunction($event)' [attr.style]='styleCss' [disabled]=\"disabled\" \n          [readonly]=\"readonly\">\n          <label class=\"sbm-label truncate\" for=\"{{randomId}}\" [attr.title]=\"_label\">{{_label}}</label>\n          \n          <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns',
                },
                providers: [abstract_ngmodel_1.MakeProvider(InputTextComponent)]
            },] },
];
/** @nocollapse */
InputTextComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
    { type: i18nTranslate_1.I18nTranslate, },
    { type: core_2.TranslateService, },
]; };
InputTextComponent.propDecorators = {
    'inputText': [{ type: core_1.ViewChild, args: ['inputText',] },],
    'ngModelText': [{ type: core_1.ViewChild, args: ['ngModelInput',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'maxLength': [{ type: core_1.Input },],
    'minLength': [{ type: core_1.Input },],
    'pattern': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'digitText': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
};
exports.InputTextComponent = InputTextComponent;
