"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
require("rxjs/add/operator/map");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
//
var MoneyComponent = (function (_super) {
    __extends(MoneyComponent, _super);
    function MoneyComponent(_translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.securityId = '';
        _this.attribute = '';
        _this.id = '';
        _this.prefix = 'R$';
        _this.decimal = ',';
        _this.thousands = '.';
        _this.decimalDigits = '2';
        _this.digitAlign = 'right';
        _this.placeholder = 'Digite um valor';
        _this.label = 'Curreny';
        _this.styleCss = '';
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.css = 'sbm-input';
        _this.notnull = ',';
        _this.disabled = false;
        _this.readonly = false;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.isNotMasterDetail = true;
        _this._options = {};
        _this._valueChecked = true;
        _this.inputValid = true;
        _this.msgInvalid = false;
        _this.randomId = '';
        _this.labelWidth = '';
        _this.msgError = 'Campo Inválido';
        _this._label = '';
        sbmInputMoneyComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        _this._translateService.onLangChange.subscribe(function (ret) {
            _this.getTranslate();
        });
        return _this;
    }
    Object.defineProperty(MoneyComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    MoneyComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.notnull && $event.target.value == '') {
            this.inputValid = false;
            this.msgError = 'Campo Obrigatório';
            $(this.money.nativeElement).removeClass('valid');
            $(this.money.nativeElement).addClass('invalid');
        }
        else {
            this.inputValid = true;
            $(this.money.nativeElement).removeClass('invalid');
            $(this.money.nativeElement).addClass('valid');
        }
        if (this.onBlur != '') {
            window[this.onBlur]($event);
            // sbmExecuteFunctions($event, this._onKeyup);
        }
    };
    MoneyComponent.prototype.ngAfterViewInit = function () {
        $(this.money.nativeElement).attr('style', this.styleCss);
        if (this.digitAlign == 'right') {
            $(this.money.nativeElement).css('direction', 'rtl');
        }
        else if (this.digitAlign == 'left') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
        else if (this.digitAlign == 'center') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
    };
    MoneyComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
            // sbmExecuteFunctions($event, this._onKeyup);
        }
    };
    MoneyComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this._options = {
            prefix: this.prefix + ' ',
            thousands: this.thousands,
            decimal: this.decimal,
            align: this.digitAlign,
            precision: this.decimalDigits
        };
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    MoneyComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    return MoneyComponent;
}(abstract_ngmodel_1.AbstractNgModel));
MoneyComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-money',
                template: "\n        <input #inputMoney\n            id=\"{{randomId}}\"\n            type=\"text\" \n            currencyMask\n            class=\"sbm-text-field {{css}}\"\n            #money\n            [(ngModel)]=\"value\"\n            [options]=\"_options\"\n            (blur)=\"blur($event)\"\n            [style]=\"styleCss\"\n            (keyup)=\"keyup($event)\"\n            [disabled]=\"disabled\" [readonly]=\"readonly\">\n          <label class=\"truncate sbm-label active\" for=\"{{randomId}}\">{{_label}}</label>\n          \n          <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(MoneyComponent)],
            },] },
];
/** @nocollapse */
MoneyComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
MoneyComponent.propDecorators = {
    'money': [{ type: core_1.ViewChild, args: ['money',] },],
    'inputMoney': [{ type: core_1.ViewChild, args: ['inputMoney',] },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'prefix': [{ type: core_1.Input },],
    'decimal': [{ type: core_1.Input },],
    'thousands': [{ type: core_1.Input },],
    'decimalDigits': [{ type: core_1.Input },],
    'digitAlign': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
};
exports.MoneyComponent = MoneyComponent;
