"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var i18n_1 = require("../../../models/i18n");
var en_1 = require("../../../mocks/i18n/en");
var fr_1 = require("../../../mocks/i18n/fr");
var pt_1 = require("../../../mocks/i18n/pt");
var TextareaComponent = (function (_super) {
    __extends(TextareaComponent, _super);
    function TextareaComponent(_el, _translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.maxLength = '';
        _this.minLength = '';
        _this.placeholder = 'Informe um valor';
        _this.label = 'Textarea';
        _this.css = 'sbm-textarea';
        _this.styleCss = '';
        _this.digitText = 'Mm';
        _this.notnull = false;
        _this.disabled = false;
        _this.readonly = false;
        _this.isNotMasterDetail = true;
        _this._columns = 'input-field col l12 s12 m12 crud-form-dynamic';
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomId = '';
        _this.labelWidth = '';
        _this._label = '';
        sbmTextareaComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        _this._translateService.onLangChange.subscribe(function (ret) {
            _this.getTranslate();
        });
        return _this;
    }
    Object.defineProperty(TextareaComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    TextareaComponent.prototype.blur = function ($event) {
        var value = $event.target.value;
        this._onBlur.emit($event);
        if (this.notnull && value.length == 0) {
            this.inputValid = false;
            $(this.textarea.nativeElement).removeClass('valid');
            $(this.textarea.nativeElement).addClass('invalid');
            this.msgError = 'Campo Obrigatório';
        }
        else {
            this.inputValid = true;
            $(this.textarea.nativeElement).removeClass('invalid');
            $(this.textarea.nativeElement).addClass('valid');
        }
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    TextareaComponent.prototype.keyup = function ($event) {
        var value = $event.target.value;
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
        if (this.minLength != '') {
            if (value.length < parseInt(this.minLength)) {
                this.inputValid = false;
                $(this.textarea.nativeElement).removeClass('valid');
                $(this.textarea.nativeElement).addClass('invalid');
                this.msgError = "O Campo deve ter no min\u00EDmo " + this.minLength + " caracteres";
            }
            else {
                this.inputValid = true;
                $(this.textarea.nativeElement).removeClass('invalid');
                $(this.textarea.nativeElement).addClass('valid');
            }
        }
        if (this.digitText == 'M') {
            this.value = $event.target.value.toUpperCase();
        }
        else if (this.digitText == 'm') {
            this.value = $event.target.value.toLowerCase();
        }
        else {
        }
    };
    TextareaComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        if (this.maxLength != '') {
            $(this.textarea.nativeElement).attr('data-length', this.maxLength);
        }
        this.randomId = 'sbm-input-' + (Math.floor((Math.random() * 100000) + 1));
    };
    TextareaComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    TextareaComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        $(this.textarea.nativeElement).attr('style', this.styleCss);
        $(document).ready(function () {
            $(me._el.nativeElement).find('span.character-counter').css({
                'float': 'righ',
                'font-size': '12px',
                'background-color': '#e53935',
                'color': '#fff',
                'margin': '5px',
                'border-radius': '5px',
                'right': '0px',
                'z-index': '9999',
                'height': '18px',
                'position': 'absolute',
            });
            me.ngModelText.valueChanges.subscribe(function (ret) {
                Materialize.updateTextFields();
            });
        });
    };
    return TextareaComponent;
}(abstract_ngmodel_1.AbstractNgModel));
TextareaComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-textarea',
                template: "        \n        <textarea id=\"{{randomId}}\" #textarea #ngModelInput=\"ngModel\" [maxlength]=\"maxLength\" class=\"sbm-text-field {{css}}\" \n        [style]=\"styleCss\" (blur)=\"blur($event)\"\n        (keyup)=\"keyup($event)\" [(ngModel)]=\"value\" [rows]=\"height\" [attr.data-length]=\"maxLength\"\n        [disabled]=\"disabled\" [readonly]=\"readonly\"></textarea>\n        <label class=\"truncate sbm-label\" for=\"{{randomId}}\">{{_label}}</label>\n          \n          <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n      ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(TextareaComponent)]
            },] },
];
/** @nocollapse */
TextareaComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
TextareaComponent.propDecorators = {
    'textarea': [{ type: core_1.ViewChild, args: ['textarea',] },],
    'ngModelText': [{ type: core_1.ViewChild, args: ['ngModelInput',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'maxLength': [{ type: core_1.Input },],
    'minLength': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'digitText': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'disabled': [{ type: core_1.Input },],
    'readonly': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onBlur': [{ type: core_1.Output },],
    '_onKeyup': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
};
exports.TextareaComponent = TextareaComponent;
