"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var array_store_1 = require("devextreme/data/array_store");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var ListOptions = (function () {
    function ListOptions(el) {
        this.el = el;
        this.idListOption = '';
        this.value = 'Valor';
        this.text = '';
    }
    ListOptions.prototype.ngOnInit = function () {
        this.idListOption = 'sbm-list-active-' + Math.floor((Math.random() * 100000) + 1);
        // console.log(this.el.nativeElement)
    };
    return ListOptions;
}());
ListOptions.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-list-option',
                template: "\n        <ng-template #internalColumnTemplate let-item=\"item\">\n            <ng-content></ng-content>\n        </ng-template>\n    ",
                host: {
                    '[text]': 'value'
                }
            },] },
];
/** @nocollapse */
ListOptions.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
]; };
ListOptions.propDecorators = {
    'value': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'columnTemplate': [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
};
exports.ListOptions = ListOptions;
var ListViewComponent = (function (_super) {
    __extends(ListViewComponent, _super);
    function ListViewComponent(_translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.dataSource = [];
        _this.notnull = false;
        _this._dataSource = ['Valor'];
        _this.text = 'Titulo';
        _this.css = 'sbm-list-view';
        _this.label = 'Selecione';
        _this.placeholder = 'Selecione um valor';
        _this.itemsSelected = [];
        _this.isNotMasterDetail = true;
        _this._columns = 'col l12 m12 s12 crud-form-dynamic sbm-list-view';
        _this.msgError = 'Selecione um valor';
        _this.styleClass = '';
        _this.filterList = null;
        _this.checkedAll = false;
        _this.selectionMultiple = false;
        _this._onClick = new core_1.EventEmitter();
        _this._onRemove = new core_1.EventEmitter();
        _this.onClick = '';
        _this.selectedItems = [];
        _this.randomClass = 0;
        _this.setValue = true;
        _this._label = '';
        sbmListViewComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
    }
    Object.defineProperty(ListViewComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 crud-form-dynamic sbm-list-view";
        },
        enumerable: true,
        configurable: true
    });
    ListViewComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 100000) + 1);
        this._dataSource = new array_store_1.default({
            data: [{ label: 'value', value: 'value' }],
            key: 'value'
        });
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
        this.onChangeValue.subscribe(function (val) {
            if (val) {
                _this.listOption.forEach(function (a, i) {
                    val.map(function (e) {
                        if (a.value == e['value']) {
                            $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                            $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                        }
                    });
                });
            }
        });
    };
    ListViewComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    ListViewComponent.prototype.keyupSearch = function () {
        var _this = this;
        this.listOption.forEach(function (a, i) {
            if (_this.value) {
                _this.value.map(function (e) {
                    if (a.value == e['value']) {
                        $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                        $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                    }
                });
            }
        });
    };
    ListViewComponent.prototype.selectItem = function (item) {
        var _this = this;
        if (this.selectionMultiple) {
            var inputChecked = $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked');
            var inputCheckedText = $(this.listOptionsEl.nativeElement).find("." + item.idListOption).text();
            if (inputChecked) {
                $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked', false);
                $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#fff');
                this.value.map(function (a, i) {
                    if (item.value == a.value) {
                        _this.value.splice(i, 1);
                    }
                });
                this._onRemove.emit(item);
            }
            else {
                $(this.listOptionsEl.nativeElement).find("#" + item.idListOption).prop('checked', true);
                $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#ddd');
                this.value.push({ text: inputCheckedText.replace(/\r?\n|\r/g, " "), value: item.value });
                this._onClick.emit(item);
            }
        }
        else {
            var inputCheckedText = $(this.listOptionsEl.nativeElement).find("." + item.idListOption).text();
            $(this.listOptionsEl.nativeElement).find("a").css('background-color', '#fff');
            $(this.listOptionsEl.nativeElement).find("." + item.idListOption).css('background-color', '#ddd');
            this.value = [{ text: inputCheckedText.replace(/\r?\n|\r/g, " "), value: item.value }];
            this._onClick.emit(item);
        }
        if (this.onClick != '') {
            window[this.onClick](item);
        }
        return false;
    };
    ListViewComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            if (!_this.selectionMultiple) {
            }
            _this.listOption.forEach(function (a, i) {
                if (_this.value) {
                    _this.value.map(function (e) {
                        if (a.value == e['value']) {
                            $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                            $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                        }
                    });
                }
            });
        });
    };
    ListViewComponent.prototype.allItems = function (all, items) {
        var _this = this;
        var allTrue = $(all).prop('checked');
        if (allTrue) {
            var _data_1 = [];
            items._results.map(function (a, i) {
                var inputCheckedText = $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).text();
                $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                _data_1.push({ text: inputCheckedText.replace(/\r?\n|\r/g, " "), value: a.value });
            });
            this.value = _data_1;
        }
        else {
            this.noneItems();
        }
        this._onClick.emit(this.value);
        if (this.onClick != '') {
            window[this.onClick](this.value);
        }
    };
    ListViewComponent.prototype.noneItems = function () {
        $(this.listOptionsEl.nativeElement).find("input").prop('checked', false);
        $(this.listOptionsEl.nativeElement).find("a").css('background-color', '#fff');
        this.value = [];
    };
    ListViewComponent.prototype.ngAfterViewChecked = function () {
        var _this = this;
        // if (this.setValue && this.value) {
        this.listOption.forEach(function (a, i) {
            if (_this.value) {
                _this.value.map(function (e) {
                    if (a.value == e['value']) {
                        $(_this.listOptionsEl.nativeElement).find("#" + a.idListOption).prop('checked', true);
                        $(_this.listOptionsEl.nativeElement).find("." + a.idListOption).css('background-color', '#ddd');
                    }
                });
            }
        });
        // console.log(this.value)
        this.setValue = false;
        // }
    };
    return ListViewComponent;
}(abstract_ngmodel_1.AbstractNgModel));
ListViewComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-list-view',
                template: "\n        <sbm-fieldset [label]=\"label\" [title]=\"placeholder\">\n            <div class=\"row\">\n                <div class=\"col l12 m12 s12\">\n                    <sbm-input-text label=\"Buscar\" columns=\"12\" [(ngModel)]=\"filterList\" (_onKeyup)='keyupSearch()'></sbm-input-text>\n                </div>\n                <div class=\"col l12 m12 s12 \">\n                    <div class=\"collection sbm-listview-container\" #listOptionsEl>\n                        <a *ngIf=\"selectionMultiple\" class=\"collection-item\" (click)=\"allItems(selectAll, listOption)\"> \n                            <input #selectAll class=\"filled-in\" type=\"checkbox\" id=\"sbmListSelectAll{{randomClass}}\"/>                \n                            <label for=\"sbmListSelectAll{{randomClass}}\" style=\"top: 8px;\"></label>\n                            Selecionar Todos\n                        </a>\n                        <a *ngFor=\"let item of listOption | sbmFilter:filterList\" class=\"collection-item {{item.idListOption}}\"> \n                            <span (click)=\"selectItem(item)\" *ngIf=\"selectionMultiple\">\n                                <input selectAllItem class=\"filled-in\" type=\"checkbox\" [id]=\"item.idListOption\"/>                \n                                <label [for]=\"item.idListOption\" style=\"top: 8px;\"></label>\n                            </span> \n                            <span (click)=\"selectItem(item)\">\n                                <ng-template [ngTemplateOutlet]=\"item.columnTemplate\" [ngOutletContext]=\"{ item: item }\"></ng-template>\n                            </span> \n                        </a>\n                    </div>\n                </div>\n            \n            </div>\n        \n            <!--<div *ngIf='selectionMultiple' style=\"text-align: center\">-->\n                <!--<a class=\"btn btn-floating waves-effect waves-light green darken-1\" (click)='allItems(listOption)'>-->\n                    <!--<i class=\"material-icons\">done_all</i>-->\n                <!--</a>-->\n                <!--<a class=\"btn btn-floating waves-effect waves-light orange darken-1\" (click)='noneItems()'>-->\n                    <!--<i class=\"material-icons\">filter_none</i>-->\n                <!--</a>-->\n            <!--</div>-->\n            \n            <div [hidden]=\"true\">\n               <ng-content></ng-content>\n            </div>\n        </sbm-fieldset>\n    ",
                host: {
                    '[class]': 'columns',
                    '[title]': 'msgError',
                    '[style]': 'styleClass'
                },
                providers: [abstract_ngmodel_1.MakeProvider(ListViewComponent)]
            },] },
];
/** @nocollapse */
ListViewComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
ListViewComponent.propDecorators = {
    'listOption': [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return ListOptions; }),] },],
    'listOptionsEl': [{ type: core_1.ViewChild, args: ['listOptionsEl',] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'text': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'itemsSelected': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    'selectionMultiple': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    '_onRemove': [{ type: core_1.Output },],
    'onClick': [{ type: core_1.Output },],
};
exports.ListViewComponent = ListViewComponent;
