"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var MultiselectComponent = (function (_super) {
    __extends(MultiselectComponent, _super);
    function MultiselectComponent(_el, _translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.securityId = '';
        _this.attribute = '';
        _this.id = '';
        _this.css = 'sbm-chip';
        _this.placeholder = 'Informe o(s) valor(es)';
        _this.isEmail = false;
        _this.styleCss = '';
        _this.isNotMasterDetail = true;
        _this._columns = 'input-field col l12 m12 s12 crud-form-dynamic';
        _this.notnull = false;
        _this.dataSource = [];
        _this._onBlur = new core_1.EventEmitter();
        _this._onKeyup = new core_1.EventEmitter();
        _this.onBlur = '';
        _this.onKeyup = '';
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.labelWidth = '';
        _this.value = [];
        _this._label = '';
        sbmMultiSelectComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
        /*this._translateService.onLangChange.subscribe(ret => {
            this.getTranslate();
        });*/
    }
    Object.defineProperty(MultiselectComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MultiselectComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "input-field col l" + value + " m12 s12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    MultiselectComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    MultiselectComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    MultiselectComponent.prototype.ngAfterViewInit = function () {
        var me = this;
        var valueInitial = {
            data: []
        };
        $(document).ready(function () {
            $(me.multiselect.nativeElement).on('chip.add', function (e, chip) {
                me.addValue(chip, e);
            });
            $(me.multiselect.nativeElement).on('chip.delete', function (e, chip) {
                me.deleteItem(chip, e);
            });
            if (me.value) {
                if (me.value.length > 0) {
                    me.value.map(function (v) {
                        valueInitial.data.push({ tag: v });
                    });
                }
            }
            $(me.multiselect.nativeElement).material_chip(valueInitial);
            // $(me.multiselect.nativeElement).find('input').css(me.styleCss);
            $(me.multiselect.nativeElement).find('input').blur(function () {
                me.blur($(me.multiselect.nativeElement).material_chip('data'), $(me.multiselect.nativeElement));
            });
            $(me.multiselect.nativeElement).find('input').keyup(function () {
                me.keyup($(me.multiselect.nativeElement));
            });
        });
    };
    MultiselectComponent.prototype.addValue = function (value, e) {
        this.value.push(value.tag);
    };
    MultiselectComponent.prototype.deleteItem = function (chip, e) {
        var _this = this;
        this.value.map(function (v, i) {
            if (v == chip.tag) {
                _this.value.splice(i, 1);
            }
        });
    };
    MultiselectComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    MultiselectComponent.prototype.blur = function (data, element) {
        this._onBlur.emit(data);
        if (this.value) {
            if (this.notnull && this.value.length == 0) {
                this.inputValid = false;
                $(this.multiselect.nativeElement).addClass('invalid');
                this.msgError = 'Campo Obrigatório';
            }
            else {
                this.inputValid = true;
                $(this.multiselect.nativeElement).removeClass('invalid');
            }
        }
        else {
            this.inputValid = false;
            $(this.multiselect.nativeElement).addClass('invalid');
            this.msgError = 'Campo Obrigatório';
        }
        if (this.onBlur != '') {
            window[this.onBlur](data);
        }
    };
    return MultiselectComponent;
}(abstract_ngmodel_1.AbstractNgModel));
MultiselectComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-multiselect',
                styles: ["\n        .invalid{\n            border-bottom-color: #F44336;\n        }\n    "],
                template: "        \n        <input type=\"hidden\" class=\"sbm-text-field\" [value]=\"value\"/>\n        <div [hidden]=\"!exibirComponente\" #multiselect class=\"{{css}}\"></div>\n        <label class=\"truncate sbm-label\" [ngStyle]=\"{'max-width': labelWidth}\">{{label}}</label>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(MultiselectComponent)],
            },] },
];
/** @nocollapse */
MultiselectComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
MultiselectComponent.propDecorators = {
    'multiselect': [{ type: core_1.ViewChild, args: ['multiselect',] },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'isEmail': [{ type: core_1.Input },],
    'styleCss': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'dataSource': [{ type: core_1.Output },],
    'onBlur': [{ type: core_1.Input },],
    'onKeyup': [{ type: core_1.Input },],
};
exports.MultiselectComponent = MultiselectComponent;
