"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../models/sharedService");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var RadioOptions = (function () {
    function RadioOptions() {
        this.idRadioOption = '';
        this.value = 'Valor';
    }
    RadioOptions.prototype.ngOnInit = function () {
        this.idRadioOption = 'sbm-radio-active-' + Math.floor((Math.random() * 1000) + 1);
    };
    return RadioOptions;
}());
RadioOptions.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-radio-option',
                template: "<div class=\"sbm-options-lenght\" [attr.data-value]=\"value\">\n        <ng-template #internalColumnTemplate let-item=\"item\">\n            <ng-content></ng-content>\n        </ng-template>\n    </div>"
            },] },
];
/** @nocollapse */
RadioOptions.ctorParameters = function () { return []; };
RadioOptions.propDecorators = {
    'value': [{ type: core_1.Input },],
    'columnTemplate': [{ type: core_1.ViewChild, args: ['internalColumnTemplate',] },],
};
exports.RadioOptions = RadioOptions;
var RadioComponent = (function (_super) {
    __extends(RadioComponent, _super);
    function RadioComponent(_el, _translateService, _sharedService) {
        var _this = _super.call(this) || this;
        _this._el = _el;
        _this._translateService = _translateService;
        _this._sharedService = _sharedService;
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.text = 'value';
        _this.css = 'sbm-radio';
        _this.label = 'Selecione';
        _this.layout = RadioEnumOrientation[RadioEnumOrientation.horizontal];
        _this.dataSource = [];
        _this.placeholder = 'Selecione um valor';
        _this.isNotMasterDetail = true;
        _this._columns = 'col l12 s12 m12 crud-form-dynamic';
        _this._dataSource = [];
        _this._onClick = new core_1.EventEmitter();
        _this.onClick = '';
        _this.notnull = false;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.randomClass = 0;
        _this.value = {};
        _this._label = '';
        _this.setValue = function (value) {
            _this.radioOptions.toArray().forEach(function (option) {
                if (option.value == value.value) {
                    _this.itemClicado(option);
                }
            });
        };
        sbmRadioComponent.push(_this);
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        return _this;
    }
    Object.defineProperty(RadioComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12 crud-form-dynamic";
        },
        enumerable: true,
        configurable: true
    });
    RadioComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.validar.call(this, this.securityId);
        this.randomClass = Math.floor((Math.random() * 1000) + 1);
        this._dataSource = [{ label: 'value', value: 'value' }];
        this._translateService.onLangChange.subscribe(function (ret) {
            _this.getTranslate();
        });
    };
    RadioComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                var colLabel = this.label.replace("i18n.", "").split('.');
                var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                for (var i = 0; i < colLabel.length; i++) {
                    caminhoTraducao += "['" + colLabel[i] + "']";
                }
                this._label = eval(caminhoTraducao);
            }
            else {
                this._label = this.label;
            }
        }
    };
    RadioComponent.prototype.itemClicado = function (itemAtual) {
        if (itemAtual) {
            this._onClick.emit(itemAtual);
            this.radioOptions.toArray().forEach(function (option) {
                if (option.value == itemAtual.value) {
                    $("." + option.idRadioOption).prop('checked', true);
                }
                else {
                    $("." + option.idRadioOption).prop('checked', false);
                }
            });
            var labelValue = $("#" + itemAtual.value).siblings('label').text();
            var value = {
                value: itemAtual.value,
                text: labelValue.replace(/\r?\n|\r/g, " ")
            };
            this.value = value;
            if (this.onClick != '') {
                window[this.onClick](itemAtual);
            }
            if (this.notnull && (JSON.stringify(itemAtual.value)).length == 0) {
                this.inputValid = false;
            }
            else {
                this.inputValid = true;
                this.placeholder = itemAtual.value;
            }
        }
    };
    RadioComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.itemClicado(_this.value);
        });
    };
    RadioComponent.prototype.ngAfterViewInit = function () {
        var _data = [];
        $('.sbm-radio-list-options-' + this.randomClass).find('sbm-radio-option').each(function (i, a) {
            _data.push({ label: $(a).text(), value: $(a).attr('value') });
        });
        this._dataSource = _data;
        var me = this;
    };
    return RadioComponent;
}(abstract_ngmodel_1.AbstractNgModel));
RadioComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-radio',
                template: "\n        <sbm-fieldset label='{{label}}' [title]=\"placeholder\">\n            <span *ngIf=\"layout == 'horizontal'\">\n                <span *ngFor=\"let item of radioOptions\">\n                    <input class=\"with-gap {{item.idRadioOption}} {{css}}\" type=\"radio\" [id]=\"item.value\" (click)=\"itemClicado(item)\"/>\n                    <label [for]=\"item.value\">\n                        <ng-template [ngTemplateOutlet]=\"item.columnTemplate\" [ngOutletContext]=\"{ item: item }\"></ng-template>\n                    </label>\n                </span>\n            </span>\n            \n            <span *ngIf=\"layout == 'vertical'\">\n                <p *ngFor=\"let item of radioOptions\">\n                    <input class=\"with-gap {{item.idRadioOption}} {{css}}\" type=\"radio\" [id]=\"item.value\" (click)=\"itemClicado(item)\"/>\n                    <label [for]=\"item.value\">\n                        <ng-template [ngTemplateOutlet]=\"item.columnTemplate\" [ngOutletContext]=\"{ item: item }\"></ng-template>\n                    </label> \n                </p>\n            </span>\n            \n            <input type=\"hidden\" class=\"data-value-hidden\" [attr.data-value]=\"value | json\">\n            <div [hidden]=\"true\" class=\"sbm-radio-list-options-{{randomClass}}\">\n               <ng-content></ng-content>\n            </div>\n        </sbm-fieldset>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(RadioComponent)]
            },] },
];
/** @nocollapse */
RadioComponent.ctorParameters = function () { return [
    { type: core_1.ElementRef, },
    { type: core_2.TranslateService, },
    { type: sharedService_1.SharedService, },
]; };
RadioComponent.propDecorators = {
    'radioOptions': [{ type: core_1.ContentChildren, args: [core_1.forwardRef(function () { return RadioOptions; }),] },],
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'text': [{ type: core_1.Input },],
    'css': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'layout': [{ type: core_1.Input },],
    'dataSource': [{ type: core_1.Input },],
    'placeholder': [{ type: core_1.Input },],
    'columns': [{ type: core_1.Input },],
    '_onClick': [{ type: core_1.Output },],
    'onClick': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
};
exports.RadioComponent = RadioComponent;
var RadioEnumOrientation;
(function (RadioEnumOrientation) {
    RadioEnumOrientation[RadioEnumOrientation["horizontal"] = 0] = "horizontal";
    RadioEnumOrientation[RadioEnumOrientation["vertical"] = 1] = "vertical";
})(RadioEnumOrientation = exports.RadioEnumOrientation || (exports.RadioEnumOrientation = {}));
