"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var i18n_1 = require("../../models/i18n");
var en_1 = require("../../mocks/i18n/en");
var fr_1 = require("../../mocks/i18n/fr");
var pt_1 = require("../../mocks/i18n/pt");
var sharedService_1 = require("../../models/sharedService");
var core_2 = require("@ngx-translate/core");
var UploadComponent = (function (_super) {
    __extends(UploadComponent, _super);
    function UploadComponent(_sharedService, _translateService) {
        var _this = _super.call(this) || this;
        _this._sharedService = _sharedService;
        _this._translateService = _translateService;
        _this._label = '';
        _this.id = '';
        _this.securityId = '';
        _this.attribute = '';
        _this.multiple = false;
        _this.notnull = false;
        _this.inputValid = true;
        _this.msgError = 'Campo Incorreto';
        _this.validationsMsg = {
            require: null
        };
        _this._columns = 'col s12 m12 l12 sbm-columns';
        _this.onUpload = new core_1.EventEmitter();
        _this.isNotMasterDetail = true;
        _this.traducao = new i18n_1.i18n(_translateService, _sharedService);
        _this.traducao.pJson = _this._sharedService.getPackagedJson();
        _this.traducao.reqEN = en_1.reqEN[0];
        _this.traducao.reqFR = fr_1.reqFR[0];
        _this.traducao.reqPT = pt_1.reqPT[0];
        _this.traducao.iniciarIdioma();
        _this._translateService.onLangChange.subscribe(function (ret) {
            _this.validationsMsg['require'] = ret.translations['i18n'][_this.traducao.pJson['name']]['validations']['fieldRequire'];
            _this.validationsMsg['minLength'] = ret.translations['i18n'][_this.traducao.pJson['name']]['validations']['fieldMinLength'];
            _this.validationsMsg['maxLength'] = ret.translations['i18n'][_this.traducao.pJson['name']]['validations']['fieldMaxLength'];
            _this.validationsMsg['pattern'] = ret.translations['i18n'][_this.traducao.pJson['name']]['validations']['pattern'];
            _this.msgError = ret.translations['i18n'][_this.traducao.pJson['name']]['validations']['require'];
            _this.getTranslate();
        });
        return _this;
    }
    UploadComponent.prototype.getTranslate = function () {
        var packageNpm = require('../../../../package.json');
        if (this.label.substring(0, 1) == '#') {
            this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][this.label.replace('#', '')];
        }
        else {
            if (this.label.substring(0, 5) == 'i18n.') {
                if (eval(this._translateService.translations[this._translateService.currentLang])) {
                    var colLabel = this.label.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
            }
            else {
                this._label = this.label;
            }
        }
    };
    Object.defineProperty(UploadComponent.prototype, "label", {
        get: function () {
            return this.privateLabel;
        },
        set: function (val) {
            this.privateLabel = val;
            var packageNpm = require('../../../../package.json');
            if (val.substring(0, 1) == '#') {
                this._label = this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name][val.replace('#', '')];
            }
            else {
                if (val.substring(0, 5) == 'i18n.') {
                    var colLabel = val.replace("i18n.", "").split('.');
                    var caminhoTraducao = "this._translateService.translations[this._translateService.currentLang].i18n[packageNpm.name]";
                    for (var i = 0; i < colLabel.length; i++) {
                        caminhoTraducao += "['" + colLabel[i] + "']";
                    }
                    this._label = eval(caminhoTraducao);
                }
                else {
                    this._label = val;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UploadComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " m12 s12 sbm-columns";
        },
        enumerable: true,
        configurable: true
    });
    UploadComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
    };
    UploadComponent.prototype.clearValue = function () {
        this.fileUploader.instance.option('value', '');
        this.inputValid = true;
    };
    UploadComponent.prototype.valueChanged = function ($data) {
        var _data = [];
        for (var _i = 0, _a = $data.value; _i < _a.length; _i++) {
            var item = _a[_i];
            var reader = new FileReader();
            reader.onload = function (readerEvt) {
                var binaryString = btoa(readerEvt.target['result']);
                _data.push({
                    base64: binaryString
                });
            };
            reader.readAsBinaryString(item);
        }
        this.onUpload.emit($data.value);
        this.value = _data;
    };
    return UploadComponent;
}(abstract_ngmodel_1.AbstractNgModel));
UploadComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-upload',
                template: "\n        <dx-file-uploader\n            #fileUploader\n            [selectButtonText]='label'\n            [multiple]=\"multiple\"\n            accept=\"*\"\n            readyToUploadMessage=\"...\"\n            uploadMode=\"useForm\"\n            (onValueChanged)=\"valueChanged($event)\"\n            (onUploadStarted)=\"valueChanged($event)\"\n        ></dx-file-uploader>\n        <span *ngIf=\"!inputValid\" class=\"msgError\">{{msgError}}</span>\n    ",
                host: {
                    '[class]': 'columns'
                },
                providers: [abstract_ngmodel_1.MakeProvider(UploadComponent)]
            },] },
];
/** @nocollapse */
UploadComponent.ctorParameters = function () { return [
    { type: sharedService_1.SharedService, },
    { type: core_2.TranslateService, },
]; };
UploadComponent.propDecorators = {
    'id': [{ type: core_1.Input },],
    'securityId': [{ type: core_1.Input },],
    'attribute': [{ type: core_1.Input },],
    'multiple': [{ type: core_1.Input },],
    'label': [{ type: core_1.Input },],
    'notnull': [{ type: core_1.Input, args: ['require',] },],
    'fileUploader': [{ type: core_1.ViewChild, args: ['fileUploader',] },],
    'columns': [{ type: core_1.Input },],
    'onUpload': [{ type: core_1.Output },],
};
exports.UploadComponent = UploadComponent;
