"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("rxjs/add/operator/map");
var funcoes_component_1 = require("./funcoes.component");
var i18nTranslate_1 = require("../services/i18nTranslate");
var i18n = (function () {
    function i18n(_translateService, _sharedService) {
        this._translateService = _translateService;
        this._sharedService = _sharedService;
        this.linguagemAtual = '';
        this._i18nTranslate = new i18nTranslate_1.I18nTranslate();
    }
    i18n.prototype.isNotBlank = function (value) {
        return funcoes_component_1.FuncoesComponent.isNotBlank(value);
    };
    i18n.prototype.iniciarIdioma = function () {
        var idiomaPadrao = "pt";
        var colIdiomas = ["en", "fr", "pt"];
        this._translateService.addLangs(colIdiomas);
        this._translateService.setDefaultLang(idiomaPadrao);
        if (this.isNotBlank(this._sharedService.getIdioma())) {
            idiomaPadrao = this._sharedService.getIdioma();
        }
        else {
            if (colIdiomas.indexOf(idiomaPadrao) == -1) {
                idiomaPadrao = "pt";
            }
        }
        this.linguagemAtual = idiomaPadrao;
        this._translateService.setDefaultLang(this.linguagemAtual);
        if (!this.isNotBlank(this._sharedService.getIdioma())) {
            this._sharedService.setIdioma(this.linguagemAtual);
        }
        this.setTraducaoProjeto();
    };
    i18n.prototype.setTraducaoProjeto = function () {
        var me = this;
        me._i18nTranslate.setLanguage(me.linguagemAtual, me.reqEN, me.reqFR, me.reqPT).then(function (retorno) {
            me._sharedService.setTraducao(me.pJson['name'], retorno);
            var traducao = me._i18nTranslate.getLanguage();
            me._translateService.setTranslation(me.linguagemAtual, traducao);
            me._translateService.use(me.linguagemAtual);
        });
    };
    return i18n;
}());
exports.i18n = i18n;
