"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ng2_webstorage_1 = require("ng2-webstorage");
var SharedService = (function () {
    function SharedService(_localStorageService) {
        this._localStorageService = _localStorageService;
    }
    SharedService.prototype.getPackagedJson = function () {
        return require('../package.json');
    };
    SharedService.prototype.getTema = function () {
        return this._localStorageService.retrieve('tema');
    };
    SharedService.prototype.setTema = function (tema) {
        this._localStorageService.store('tema', tema);
    };
    SharedService.prototype.getIdioma = function () {
        return this._localStorageService.retrieve('idioma');
    };
    SharedService.prototype.setIdioma = function (idioma) {
        this._localStorageService.store('idioma', idioma);
    };
    SharedService.prototype.getTraducao = function (appName) {
        return this._localStorageService.retrieve('i18n/' + appName) || [];
    };
    SharedService.prototype.setTraducao = function (appName, vlr) {
        this._localStorageService.store('i18n/' + appName, new Array(vlr));
    };
    SharedService.prototype.getTempoOciosoAPP = function (appName) {
        var colAPPAbertas = this._localStorageService.retrieve('tempo-ocioso-app') || [];
        return colAPPAbertas.filter(function (obj) {
            return (obj["titulo"] == appName);
        });
    };
    SharedService.prototype.setTempoOciosoAPP = function (appName, vlr) {
        var pos = -1;
        var colAPPAbertas = this._localStorageService.retrieve('tempo-ocioso-app') || [];
        colAPPAbertas.map(function (obj, i) {
            if (obj["titulo"] == appName) {
                pos = i;
            }
        });
        if (pos == -1) {
            colAPPAbertas.push({ "titulo": appName, "vlr": vlr });
        }
        else {
            colAPPAbertas[pos]["vlr"] = vlr;
        }
        this._localStorageService.store('tempo-ocioso-app', colAPPAbertas);
    };
    SharedService.prototype.duplicarColecao = function (oldArray) {
        var newArray = [];
        oldArray.forEach(function (item) {
            newArray.push(Object.assign({}, item));
        });
        return newArray;
    };
    SharedService.prototype.formataTitulo = function (text) {
        var words = text.toLowerCase().split(" ");
        for (var a = 0; a < words.length; a++) {
            var w = words[a];
            words[a] = w[0].toUpperCase() + w.slice(1);
        }
        return words.join(" ");
    };
    return SharedService;
}());
SharedService.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
SharedService.ctorParameters = function () { return [
    { type: ng2_webstorage_1.LocalStorageService, },
]; };
exports.SharedService = SharedService;
